package com.example.sqlrun.conf;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;

@Configuration
@Slf4j
public class DbConfiguration {
    @Value("${spring.datasource.driver-class-name}")
    private String className;

    @Value("${spring.datasource.password}")
    public String password;
    @Value("${spring.datasource.url}")
    private String url;
    @Value("${spring.datasource.username}")
    private String username;

    @Bean(name = "statement")
    @Primary
    public Statement executeSql(){
        try {
            Class.forName(className);
            Connection connection = DriverManager.getConnection(url, username, password);
            return connection.createStatement();
        } catch (Exception e) {
            log.error(e.getMessage());
        }
        return null;
    }
}
