package com.example.sqlrun.fixSql;

import com.shanghaigeography.Util.DateUtils;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @ClassName: makePartitionSql
 *
 * @description: TODO
 * @author: sbj
 * @time: 2023/12/5 13:53 @Version: 1.0
 */
public class MakePartitionSql {

  /**
   *
   * @param tableName   the name of the table
   * @param partitionNamePrefix   分区前缀
   * @param tableSpaceName        表空间的名称
   * @param startDate             开始时间     'yyyy-MM-dd 00:00:00'
   * @param wantedDay             需要创建多少个
   * @return
   */
  public static List<String> makePartitionSqlByDay(String tableName, String partitionNamePrefix, String tableSpaceName,Date startDate,Integer wantedDay){
    String startSql = "alter table " + tableName + " add partition " + partitionNamePrefix;
    Date maxDate = DateUtils.dayAddNum(startDate, wantedDay);
    ArrayList<String> targetSqls = new ArrayList<>();
    while (startDate.compareTo(maxDate) < 0){
      Date stDate = startDate;
      startDate = DateUtils.dayAddNum(startDate,1);
      String targetSql = startSql + DateUtils.dateToString(stDate,"yyyyMMdd") + " values less than " + "(TO_DATE('" + DateUtils.dateToString(startDate,"yyyy-MM-dd 00:00:00") + "'" + "," + "'" + "yyyy-MM-dd hh24:mi:ss" + "'" + "))" + " tablespace " + tableSpaceName;
      targetSqls.add(targetSql);
    }
    //boolean execute = statement.execute("alter table GHJG_CHANNEL.TEST ADD PARTITION TEST20231202 VALUES LESS THAN (TO_DATE('2023-12-03 00:00:00','YYYY-MM-DD hh24:mi:ss')) tablespace GHJGCHANNEL_TEST");

    return targetSqls;
  }

  public static List<String> makePartitionSqlByMonth(String tableName, String partitionPrefix,
      String tablespaceName,Date date) {
    String startSql = "alter table " + tableName + " add partition " + partitionPrefix;
    ArrayList<String> targetSqls = new ArrayList<>();
    while (date.getMonth()+1 <= 12){
      String targetSql = startSql + DateUtils.dateToString(date,"yyyyMM") + " values less than " + "(TO_DATE('" + DateUtils.dateToString(DateUtils.monthAddNum(date,1),"yyyy-MM-01 00:00:00") + "'" + "," + "'" + "yyyy-MM-dd hh24:mi:ss" + "'" + "))" + " tablespace " + tablespaceName;
      targetSqls.add(targetSql);
      if (date.getMonth()+1 == 12) {
        break;
      }
      date = DateUtils.monthAddNum(date,1);

    }
    return targetSqls;
  }

  public static List<String> makePartitionSqlByDayForQuarter(String tableName, String partitionNamePrefix,
      String tableSpaceName, Date date) {
    String startSql = "alter table " + tableName + " add partition " + partitionNamePrefix;
    ArrayList<String> targetSqls = new ArrayList<>();
    Date maxDate = DateUtils.monthAddNum(date, 3);
    while (date.compareTo(maxDate) < 0){
      Date stDate = date;
      date = DateUtils.dayAddNum(date,1);
      String targetSql = startSql + DateUtils.dateToString(stDate,"yyyyMMdd") + " values less than " + "(TO_DATE('" + DateUtils.dateToString(date,"yyyy-MM-dd 00:00:00") + "'" + "," + "'" + "yyyy-MM-dd hh24:mi:ss" + "'" + "))" + " tablespace " + tableSpaceName;
      targetSqls.add(targetSql);
    }
    return targetSqls;
  }
}
