package com.example.sqlrun.fixSql;

import com.example.sqlrun.myEnum.SpaceEnum;
import com.shanghaigeography.Util.DateUtils;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.util.StringUtils;

/**
 * @ClassName: makeTableSpace
 *
 * @description: TODO
 * @author: sbj
 * @time: 2023/12/5 13:50 @Version: 1.0
 */
public class MakeTableSpace {
  public static List<Map> makeTableSpaceSqlByMonth(
      String tableSpaceNamePrefix,
      String tableSpaceFileNamePrefix,
      String tableSpacePath,
      Integer initSize,
      Integer nextSize,
      Integer maxSize,
      Date startDate,
      Integer maxTableSpaceWanted)
      throws ParseException {
    List<Map> tableSpaceSql = new ArrayList<>();
    String startSql = "create tablespace " + "\"" + tableSpaceNamePrefix;
    String datafile = " datafile ";
    if (StringUtils.isEmpty(tableSpacePath) || !StringUtils.hasLength(tableSpacePath)) {
      tableSpacePath = "D:\\app\\Administrator\\dm\\TEST\\" + tableSpaceFileNamePrefix;
    }else {
      tableSpacePath =tableSpacePath +  "/" + tableSpaceFileNamePrefix;
    }
    //Date stDate = DateUtils.stringToDate(startDate, "yyyyMM");
    Date maxDate = DateUtils.monthAddNum(startDate, maxTableSpaceWanted);
    while (startDate.compareTo(maxDate) < 0) {
      String yyyyMM = DateUtils.dateToString(startDate, "yyyyMM");
      String targetSql =
          startSql
              + yyyyMM
              + "\""
              + datafile
              + "'"
              + tableSpacePath
              + yyyyMM
              + ".DBF"
              + "'"
              + " size "
              + initSize + "M"
              + " autoextend on next "
              + nextSize + "M"
              + " maxsize "
              + maxSize + "M";
      HashMap<String, Object> hashMap = new HashMap<>();
      hashMap.put(SpaceEnum.TABLESPACE_SQL.getName(),targetSql);
      hashMap.put(SpaceEnum.DATE.getName(), startDate);
      hashMap.put(SpaceEnum.TABLESPACENAME.getName(),tableSpaceNamePrefix + yyyyMM);
      tableSpaceSql.add(hashMap);
      startDate = DateUtils.monthAddNum(startDate, 1);
    }
    return tableSpaceSql;
  }

  public static List<Map> makeTableSpaceSqlByYear(String tablespacePrefix, String datafilePrefix,
      String datafilePath, Integer initSize, Integer nextSize, Integer maxSize,
      Date lastAddTablespaceTime, Integer wanted) {
    List<Map> tableSpaceSql = new ArrayList<>();
    String startSql = "create tablespace " + "\"" + tablespacePrefix;
    String datafile = " datafile ";
    if (StringUtils.isEmpty(datafilePath) || !StringUtils.hasLength(datafilePath)) {
      datafilePath = "D:\\app\\Administrator\\dm\\TEST\\" + datafilePrefix;
    }else {
      datafilePath =datafilePath +  "/" + datafilePrefix;
    }
    Date maxDate = DateUtils.yearAddNum(lastAddTablespaceTime, wanted);
    while (lastAddTablespaceTime.compareTo(maxDate) < 0){
      String year = DateUtils.dateToString(lastAddTablespaceTime,"yyyy");
      String targetSql = startSql + year + "\"" + datafile + "'" + datafilePath + year + ".DBF" + "'" + " size " + initSize + "M" + " autoextend on next " + nextSize + "M" + " maxsize " + maxSize + "M";
      HashMap<String, Object> hashMap = new HashMap<>();
      hashMap.put(SpaceEnum.TABLESPACE_SQL.getName(),targetSql);
      hashMap.put(SpaceEnum.DATE.getName(), lastAddTablespaceTime);
      hashMap.put(SpaceEnum.TABLESPACENAME.getName(),tablespacePrefix + year);
      tableSpaceSql.add(hashMap);
      lastAddTablespaceTime  = DateUtils.yearAddNum(lastAddTablespaceTime,1);
    }
    return tableSpaceSql;
  }

  public static List<Map> makeTableSpaceSqlByQuarter(String tablespacePrefix, String datafilePrefix,
      String datafilePath, Integer initSize, Integer nextSize,
      Integer maxSize, Date lastAddTablespaceTime, Integer wanted) {
    List<Map> tableSpaceSql = new ArrayList<>();
    String startSql = "create tablespace " + "\"" + tablespacePrefix;
    String datafile = " datafile ";
    if (StringUtils.isEmpty(datafilePath) || !StringUtils.hasLength(datafilePath)) {
      datafilePath = "D:\\app\\Administrator\\dm\\TEST\\" + datafilePrefix;
    }else {
      datafilePath =datafilePath +  "/" + datafilePrefix;
    }
    // 根据季度建表空间,3个月为一个季度
    for (Integer i = 0; i < wanted; i++) {
      Integer quarter= WhateQuarter(lastAddTablespaceTime.getMonth() + 1);
      String targetSql = startSql + DateUtils.getYear(lastAddTablespaceTime) + quarter + "\"" + datafile + "'" + datafilePath + DateUtils.getYear(lastAddTablespaceTime) + quarter + ".DBF" + "'" + " size " + initSize + "M" + " autoextend on next " + nextSize + "M" + " maxsize " + maxSize + "M";
      HashMap<String, Object> hashMap = new HashMap<>();
      hashMap.put(SpaceEnum.TABLESPACE_SQL.getName(),targetSql);
      hashMap.put(SpaceEnum.DATE.getName(), lastAddTablespaceTime);
      hashMap.put(SpaceEnum.TABLESPACENAME.getName(), tablespacePrefix + DateUtils.getYear(lastAddTablespaceTime) + quarter);
      tableSpaceSql.add(hashMap);
      lastAddTablespaceTime = DateUtils.monthAddNum(lastAddTablespaceTime,3);
    }
    return tableSpaceSql;
  }

  private static Integer WhateQuarter(int i) {
    if (i >= 0 && i<= 3){
      return 1;
    }else if (i>=4 && i<=6){
      return 2;
    }else if (i>=7 && i<=9){
      return 3;
    }else if (i>=10 && i<=12){
      return 4;
    }
    return null;
  }
}
